Interface IcCopperBar
   display  .i (nX.i, nY.i)
   release  .i ()
EndInterface

Structure cCopperBar
   *VTABLE
   
   idSprite2D     .i 
   idSprite3D     .i 
   nTransparency  .i
EndStructure

Procedure.i cCopperBar_display (*this.cCopperBar, nX.i, nY.i)
   
   DisplaySprite3D (*this\idSprite3D, nX, nY, *this\nTransparency)
   
   ProcedureReturn #Null
EndProcedure

Procedure.i cCopperBar_release (*this.cCopperBar)
   
   FreeSprite3D (*this\idSprite3D)
   FreeSprite   (*this\idSprite2D)
   FreeMemory   (*this)
   
   ProcedureReturn #Null
EndProcedure

Procedure.i CreateObject_cCopperBar (nWidth.i, nHeight.i, nTransparency.i, nStartColor.i, nEndColor.i)
   Protected   *this       .cCopperBar = AllocateMemory (SizeOf (cCopperBar))
   Static      idTempImage .i
   
   If Not (idTempImage)
      idTempImage = CreateImage (#PB_Any, 256, 256)
   EndIf
   
   *this\VTABLE         = ? VT_cCopperBar
   *this\idSprite2D     = CreateSprite (#PB_Any, 256, 256, #PB_Sprite_Texture)
   *this\nTransparency  = nTransparency
   
   StartDrawing   (ImageOutput (idTempImage))   
   DrawingMode    (#PB_2DDrawing_Gradient)      
   BackColor      (nStartColor)
   FrontColor     (nStartColor)  
   GradientColor  (0, nStartColor)
   GradientColor  (0.5, nEndColor)          
   LinearGradient (0, 0, 0, 256)    
   Box            (0, 0, 256, 256)  
   StopDrawing    () 
   
   StartDrawing   (SpriteOutput (*this\idSprite2D))  
   DrawImage      (ImageID (idTempImage), 0, 0, 256, 256)
   StopDrawing    () 
   
   *this\idSprite3D = CreateSprite3D (#PB_Any, *this\idSprite2D)
   
   ZoomSprite3D (*this\idSprite3D, nWidth, nHeight)
   
   ProcedureReturn *this
EndProcedure

DataSection
   VT_cCopperBar:
   Data.i @ cCopperBar_display ()
   Data.i @ cCopperBar_release ()
EndDataSection

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 51
; FirstLine = 38
; Folding = -
; EnableXP
; UseMainFile = main.pb
; CurrentDirectory = C:\Program Files (x86)\PureBasic\
; CompileSourceDirectory