; ******************************************************
; *   2009 & 2010 By Hroudtwolf
; *   PureBasic 4.x
; ******************************************************

XIncludeFile "cCopperBar.class.pb"

#COPPERBARS_MAX = 10

Structure tCopperBars
   blInit         .i
   *objCopperBarA .IcCopperBar [#COPPERBARS_MAX + 1]
   *objCopperBarB .IcCopperBar [#COPPERBARS_MAX + 1]
   nY             .i           [#COPPERBARS_MAX]
EndStructure

Procedure.i GetModule_CopperBars ()
   Static this.tCopperBars
   
   ProcedureReturn this
EndProcedure

Procedure.i CopperBars_Init ()
   Protected *this         .tCopperBars = GetModule_CopperBars ()
   Protected nI            .i
   Protected nTranspareny  .i
   
   While (nI < #COPPERBARS_MAX)
      nTransparency = (200 / #COPPERBARS_MAX) * nI
   
      *this\objCopperBarA   [nI] = CreateObject_cCopperBar (800, 20, Int (nTransparency), $0010CC, $00FFFF)
      *this\objCopperBarB   [nI] = CreateObject_cCopperBar (800, 20, Int (nTransparency), $000000, $00FFFF)
      
      *this\nY             [nI] = nI * 25
      nI + 1
   Wend
   
   ProcedureReturn #Null
EndProcedure

Procedure.i CopperBars_Update ()
   Protected *this         .tCopperBars   = GetModule_CopperBars ()
   Protected nI            .i             = 0
   
   While (*this\objCopperBarA [nI])
   
      *this\nY [nI] + 2
      If (*this\nY [nI] > 360) : *this\nY [nI] = 0 : EndIf
    
      nI + 1
   Wend
   
   ProcedureReturn #Null
EndProcedure

Procedure.i CopperBars_Display ()
   Protected *this         .tCopperBars   = GetModule_CopperBars ()
   Protected nI            .i             = 0
   
   While (*this\objCopperBarA [nI])
   
      *this\objCopperBarA [nI]\display (0, 100 + (GSin (*this\nY [nI]) * 100))   
      *this\objCopperBarB [nI]\display (0, 480 - (GSin (*this\nY [nI]) * 100)) 
      nI + 1
   Wend
   
   ProcedureReturn #Null
EndProcedure

; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableXP
; UseMainFile = main.pb
; CurrentDirectory = C:\Program Files (x86)\PureBasic\
; CompileSourceDirectory