; ******************************************************
; *   2009 & 2010 By Hroudtwolf
; *   PureBasic 4.x
; ******************************************************

#SCREEN_CX = 800
#SCREEN_CY = 600

XIncludeFile "common.inc.pb"
XIncludeFile "gfx.inc.pb"
XIncludeFile "copperbars.module.pb"
XIncludeFile "starscroller.module.pb"
XIncludeFile "scrolltext.module.pb"
XIncludeFile "updater.module.pb"


DoOrDie (GFX_Init (#GFX_INIT_2D | #GFX_INIT_3D), "Can't initialize DirectX environment.")
DoOrDie (GFX_OpenWindow (#SCREEN_CX , #SCREEN_CY, "Intro"), "Can't open GFX screen.")

;-- Initializing GFX modules.
CopperBars_Init   ()
StarScroller_Init ()

ScrollText_Add ("Hello PureBasic-Lounge.com ..... Have fun with this tiny test intro. Feel free to use the sources.... ")


;-- Registering update funcs for time based updates.
Updater_AddItem (@ CopperBars_Update   () , 20)
Updater_AddItem (@ StarScroller_Update () , 10)
Updater_AddItem (@ ScrollText_Update   () , 10)

Repeat
   GFX_WindowEventDispatcher ()   
   FlipBuffers ()
   ClearScreen (#Black)
   
   Updater_Update ()
   
   Start3D ()
      StarScroller_Display ()
      ScrollText_Display   (0, 300) 
      CopperBars_Display   () 
   Stop3D ()
   
   Delay (0)
ForEver


; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 29
; FirstLine = 27
; EnableXP
; CurrentDirectory = C:\Program Files (x86)\PureBasic\
; CompileSourceDirectory