; ******************************************************
; *   2009 & 2010 By Hroudtwolf
; *   PureBasic 4.x
; ******************************************************

Prototype.i pUpdaterProc ()

Structure tUpdaterItem
   *ptrUpdaterProc.pUpdaterProc
   tmUpdateTick   .i
   tmNextTick     .i
EndStructure

Global NewList updater.tUpdaterItem ()

Procedure.i Updater_AddItem (*ptrProc, tmUpdateTick.i)

   AddElement (updater ())
   updater ()\ptrUpdaterProc = *ptrProc
   updater ()\tmUpdateTick   = tmUpdateTick 
   
   ProcedureReturn #Null
EndProcedure

Procedure.i Updater_Update ()

   ForEach (updater ())
      If (updater ()\tmNextTick < ElapsedMilliseconds ())
         updater ()\tmNextTick = ElapsedMilliseconds () + updater ()\tmUpdateTick
         
         updater ()\ptrUpdaterProc ()
      EndIf
   Next
   
   ProcedureReturn #Null
EndProcedure
; IDE Options = PureBasic 4.40 (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableXP
; CurrentDirectory = C:\Program Files (x86)\PureBasic\
; CompileSourceDirectory